require "active_object"
require "open3"
require "rbconfig"

require "active_scripts/version"
require "active_scripts/base"
require "active_scripts/operating_system"

[:preparation, :recipe, :package].each do |script|
  require "active_scripts/#{script}"
  require "active_scripts/#{script}s/base"
end

ActiveScripts::Preparation::PREPARATIONS.each { |preparation| require("active_scripts/preparations/#{preparation}") }
ActiveScripts::Recipe::RECIPES.each { |recipe| require("active_scripts/recipes/#{recipe}") }
ActiveScripts::Package::PACKAGES.each { |package| require("active_scripts/packages/#{package}") }