module ActiveScripts
  module Packages
    class All < ActiveScripts::Packages::Base

      # INFO: ActiveScripts::Packages::All contains code that
      #   executes all packages.

      private

      def install
        notify_command_unavailable!
      end

      def upgrade
        case $operating_system
        when :macosx, :linux
          execute_command!("brew update --all")
          output = execute_command!("brew upgrade --all")
          say_warning("   [!] #{output}") unless option_dry_run? || package_output?(output)
          output = execute_command!("brew doctor")
          say_warning("   [!] #{output}") unless option_dry_run? || package_output?(output, includes: "Your system is ready to brew.")
          say_ok("   Upgrade complete!")
        else
          notify_package_unavailable!
        end
      end

      def uninstall
        notify_command_unavailable!
      end

    end
  end
end