module ActiveScripts
  module Recipes
    class Rails < ActiveScripts::Recipes::Base

      # INFO: ActiveScripts::Recipes::Rails contains code that
      #   retrieves rails related packages.

      def packages
        prompt_environment!
        assert_valid_environment!

        # Check for non-root user
        packages = ["homebrew", "rbenv", "ruby_build", "ruby", "rails"]
        packages.push(find_or_initialize_databases!)

        case @environment
        when :staging, :production
          packages.push("nginx")
        end

        return(packages.flatten)
      end

    end
  end
end